#!/usr/bin/env python3

# in console aufrufen oder aus einer shell
# /usr/bin/check_cam.sh
# schauen ob eine osam running ist und sie dann stoppen
import os
import shutil
import sys
import time
import requests


import subprocess
import logging
import requests
from shutil import copyfile
from os import remove
from os.path import isfile

# Konfiguration
LOGDIR = "/tmp"
LOGFILE = os.path.join(LOGDIR, "kitte888_oscam_download.log")

# Logging einrichten
logging.basicConfig(filename=LOGFILE, level=logging.INFO, format='%(asctime)s - %(message)s')
logging.info("**************************** START *******************************")
#########################################################################################################

def download_file(remote_urloscam, local_path):
	logging.info("download ")
	logging.info(remote_urloscam)
	logging.info(local_path)

	response = requests.get(remote_urloscam)

	logging.info("response1")
	if response.status_code == 200:
		logging.info("response2")
		expected_size = int(response.headers.get('content-length', 0))
		with open(local_path, "wb") as file:
			for chunk in response.iter_content(chunk_size=1024):
				file.write(chunk)

		# Überprüfe die Größe der heruntergeladenen Datei
		actual_size = os.path.getsize(local_path)

		if actual_size == expected_size:
			logging.info("Download abgeschlossen und Dateigröße stimmt ueberein.")
			# neue Oscam copiere , aktuelle
			source_path = "/etc/tuxbox/config/oscamicamall/versionen/oscamicamall"
			destination_path = "/etc/tuxbox/config/oscamicamall/binary/oscamicamall"
			shutil.copy(source_path, destination_path)
			logging.info("file copiert")
			subprocess.run(["chmod", "+x", destination_path], check=True)
			logging.info("rechte gesetzt ")
			#rm -f /tmp/${CAMNAME}.new
		else:
			logging.info("datei stimmt nicht ")
	
			
	else:
			
		logging.info("kein download")	
	
#########################################################################################################
def update_version():
	logging.info("Download oscam schauen welche cpu")

	# ------------------------------------------ hier wo es reincopiert wird ---------------------------
	local_path = "/etc/tuxbox/config/oscamicamall/versionen/oscamicamall"
	cpu_path = "/etc/tuxbox/config/oscamicamall/versionen/cpu"
	remote_urloscam = "https://magentacloud.de/s/dBmmC8JEjiyYTy8/download?path=%2F&files=oscamarm"
	# --------------------------------------------------------------------------------------------------

	try:
		with open(cpu_path, "r") as file:
			content = file.read().strip()
			logging.info(f"CPU ist: {content}")
			print(content)
			cpuversion = content
		print(cpuversion)
	except FileNotFoundError:
		logging.error("Die Datei {} wurde nicht gefunden.".format(cpu_path))
	except Exception as e:
		logging.error("Ein Fehler ist aufgetreten: {}".format(e))

	if cpuversion == "arm" :
		logging.info("cpu arm ")
		remote_urloscam = "https://magentacloud.de/s/dBmmC8JEjiyYTy8/download?path=%2F&files=oscamarm"
	else:
	
		if  cpuversion == "mipsel" :
			logging.info("cpu mipsel")
			remote_urloscam = "https://magentacloud.de/s/dBmmC8JEjiyYTy8/download?path=%2F&files=oscammipsel"

		else:
		
			if  cpuversion == "aarch" :
				logging.info("cpu aarch")
				remote_urloscam = "https://magentacloud.de/s/dBmmC8JEjiyYTy8/download?path=%2F&files=oscamaarch"
			else:
				logging.info("cpu fehler nicht gefunden")
			

	download_file(remote_urloscam, local_path)	

if __name__ == "__main__":
    update_version()
